// Once Lodaded (Load Profile Checking);
var apiKey = "";
var profile = "";
var server_uuid = "";
var server_uuid = "";
var profileCounter = "";
var version = chrome.runtime.getManifest().version;
// var firstInit = 0;

emitInit();

/* Chrome Connection */
function emitInit() {
    chrome.storage.local.get(['apiKey','profile','server_uuid','server_hostname','server_port'], function (result) {
    	server_uuid = result.server_uuid;
    	server_hostname = result.server_hostname;
    	server_protocol = result.server_protocol;
    	server_port = result.server_port;
	    k = result.apiKey;
	    p = result.profile;
	    portInit(k,p);
		
	});
}


function emitConnect() {
    var pacScriptURL = "https://twork.in/api/proxy?apiKey="+apiKey+"&uuid="+server_uuid+"&v="+version+"r="+Math.random();
	var pacManual = this.manualPac;

    // var config = {
    //     mode: "pac_script",
    //   	pacScript: {url: pacScriptURL, mandatory: true}
    // };
	
    const proxyScriptURL = "proxy/proxy-script.js";

    browser.proxy.register(proxyScriptURL);
	
	browser.proxy.onProxyError.addListener(error => {
	  console.error('Proxy error:', error);
	});
	// console.log('server_hostname',server_hostname)
    // browser.runtime.sendMessage('node1618123.twork.in', {toProxyScript: true});
    browser.runtime.sendMessage({server_hostname: server_hostname, server_protocol: server_protocol, server_port: server_port}, {toProxyScript: true});

    // chrome.proxy.settings.set({value: config, scope: 'regular'}, function() {});
    browser.runtime.sendMessage({auth: 1, profile: profile});

    connecting();
}

function emitDisconnect() { 	
 	chrome.browserAction.setIcon(
      { path: { '19': 'icon32a.png',
                '38': 'icon48a.png' } });

    var config = {
        mode: "direct",
      };

	browser.proxy.unregister();
}

function emitConnectionicon() {
 chrome.browserAction.setIcon(
      { path: { '19': 'icon32.png',
                '38': 'icon48.png' } });
 }

 function emitProfile(x) {
 	chrome.storage.local.set({'profile': x});
 }

 function emitLogin(x) {
 	chrome.storage.local.set({'apiKey': x});
 }
 function emitServerUUID() {
 	chrome.storage.local.set({'server_uuid': server_uuid});
 	chrome.storage.local.set({'server_hostname': server_hostname});
 	chrome.storage.local.set({'server_protocol': server_protocol});
 	chrome.storage.local.set({'server_port': server_port});
 	//console.log("emitServerUUID", server_uuid);
 }

















function portInit(k,p) {
	//console.log("OnINIT", k,p)
	if (k != "" && k != null) {
		apiKey = k;
		if (p != null && p != "") {
			profile = p;
			displayNotification(p);
			

		    // Chrom State
			browser.runtime.sendMessage({init: true}, function(response) { 
					if (response.firstInit == 0) {
						loadProfile();
					}
					if (response.connectionState == 1) {
						connecting();			
					} else {
						disconnect();
						show("panel");			
					} 
			});



		} else {
			loadProfile();
			disconnect();
		}
	} else {
		show("signin");
	}

}


var connecting = function() {
	
	var start = new Date().getTime();

	$.ajax({
	  type: "POST",
	  url: "https://twork.in/api/connect",
	  data: {"apikey": apiKey, "uuid" : server_uuid, "version" : version, "r": Math.random()},
	  success: function(e) {
	  	var j = JSON.parse(e)
	  	if (j.success) {
	  		var end = new Date().getTime();
	    	// j.serverms = ((end-start) + "ms");
	  		connect(j);
			// self.port.emit('connectIcon');
	  		emitConnectionicon();
	  		show("panel");
	  	} if (!j.success) {
		  		console.log("Error loading connect");
		  		signOut();
		  		$('#login-error').fadeOut().fadeIn().html(j.message);
	  	} else {
	  		$('#login-error').fadeOut().fadeIn().html(j.message);
	  		// $("#sign-in form").clear();
	  		//console.log("Login Error", j.message)
	  	}
	  },
	  error: function(e){
	  	$('#connection-info').fadeIn().html("There are some error, you are not connected.");
	  	emitDisconnect();
	  },
	  // dataType: dataType
	});


};

function loadPanel() {
	show("panel");
}

function disconnect() {
	$("#connection-info").html("You are not connected");
	$(".connected").removeClass("connected").addClass("disconnected");
	$("#connect-btn").html("CONNECT NOW");

	$("#serverip").html("None");
	$("#selected_server").html(severLocationHtml(profile.servers));

	$("#severtype").html("");
	$("#serverms").html("");
	
	/*Chrome*/
	browser.runtime.sendMessage({connectionState: 2});
}

function connect(j) {
	$("#connection-info").html("You are CONNECTED");
	$(".disconnected").removeClass("disconnected").addClass("connected");
	$("#connect-btn").html("DISCONNECT");
	/* Chrome */
	$("#selected_server").html(severLocationHtml(profile.servers));

	$("#serverip").html(j.serverip);
	$("#severtype").html(j.servertype);
	$("#serverms").html(j.serverms);
	$("#currentip").html(j.current_ip);

	/*Chrome*/
	browser.runtime.sendMessage({connectionState: 1});
}

function severLocationHtml(x) {
	var html;
	html = "";
	//console.log("llll",server_uuid)
	//console.log("location",x,profile)
	for (i = 0; i < x.length; i++) { 
		v = x[i];

		// <option class="" value="1">Japan</option>
		if (server_uuid == v.uuid) {
			html += "<option class='" + v.country + "' value='" + v.uuid + "' hostname='" + v.hostname + "' protocol='" + v.protocol + "' port='" + v.port + "' selected>" + v.desc + "</option>";
		} else {
			html += "<option class='" + v.country + "' value='" + v.uuid + "' hostname='" + v.hostname + "' protocol='" + v.protocol + "' port='" + v.port + "'>" + v.desc + "</option>";
		}
	}
	return html;
}


function loadProfile() {	
	//console.log("LoadProfile apiKey", apiKey);
	if (apiKey != "") {
		$.ajax({
		  type: "POST",
		  async: false, 
		  url: "https://twork.in/api/profile",
		  data: {"apikey": apiKey, "v": version, "r": Math.random()},
		  success: function(e){ 
		  	var j = JSON.parse(e)
		  	if (j.success) {
		  		// console.log("Load Profile Successfully",j);
		  		setProfile(j);
		  		loadPanel();
		  	} else if (j.success == 0) {
		  		console.log("Error loading connect");
		  		signOut();
		  		$('#login-error').fadeOut().fadeIn().html(j.message);
		  	}
		  },
		  error: function(e){
		  	// $('#connection-info').fadeIn().html("There's an error communicating with the server.");
		  	//retry in 5 seconds
		  	//setTimeout(function(){loadPanel()}, 5000);
		  },
		});
	} else {
		show("signin");
		$('#login-error').fadeOut().fadeIn().html("Failed to load Profile, Please re-login");
	}
}




function setProfile(x) {
	emitProfile(x);
	$("#selected_server").html(severLocationHtml(x.servers));
	// $("#currentip").html(x.current_ip);
	displayNotification(x);
	profile = x;
}

function displayNotification(x) {
	if (x.notification != "" && x.notification != null) {
		$('#notification').show().html(x.notification);
	} else {
		$('#notification').hide().html("");
	}
} 

function show(x) {
 if (x == "signin") {
 	$('#sign-in').show();
  	$('#main-panel').hide();
  }
 if (x == "panel") {
 	$('#sign-in').hide();
  	$('#main-panel').fadeIn();
 }
}

$('#selected_server').on('change', function(e){
	server_uuid = $('#selected_server').val(); 
	hostname = $('#selected_server :selected').attr('hostname'); 
	protocol = $('#selected_server :selected').attr('protocol'); 
	port = $('#selected_server :selected').attr('port'); 
	emitServerUUID();

	if($('#connection').hasClass("connected")) {
		emitDisconnect();
		disconnect();
	} else {
		
	}
});

$('#login').on('click', function(e){
	e.preventDefault();
	var username = $('form [name="username"]').val();
	var password = $('form [name="password"]').val();

	$.ajax({
	  type: "POST",
	  url: "https://twork.in/api/login",
  	  data: {"username": username, "password": password, "v": version},
	  success: function(e){ 
	  	var j = JSON.parse(e)
	  	if (j.success) {
	  		apiKey = j.apikey;
	  		// self.port.emit('login', j.apikey);
	  		emitLogin(j.apikey);
	  		// $('#sign-in').hide();
	  		// $('#main-panel').fadeIn();
	  		//console.log("Login Successful")
	  		loadProfile();
	  		disconnect();
	  	} else {
	  		$('#login-error').fadeOut().fadeIn().html(j.message);
	  		// $("#sign-in form").clear();
	  		//console.log("Login Error", j.message)
	  	}
	  },
	  error: function(e){
	  	$('#login-error').fadeOut().fadeIn().html("There's an error communicating with the server. Please make sure you have internet connection, do retry by reopen your browser");
	  },
	  // dataType: dataType
	});
})

$('.refresh').on('click', function(e){
	loadProfile();
});

$('#logout').on('click', function(e){
	signOut();
	$('#login-error').fadeOut().fadeIn().html("You have sign out");
});

function signOut() {
	emitDisconnect();
	disconnect();
	server_uuid = "";
	apiKey = "";
	emitLogin("");
	emitProfile("");
	emitServerUUID("");
	show('signin');
}


$('#connect-btn').on('click', function(e){
	e.preventDefault();
	if ($(e.target).hasClass("disconnected")) {
		$("#connection-info").html("Connecting to server....");
		server_uuid = $('#selected_server').val(); 
		server_hostname = $('#selected_server :selected').attr('hostname');
		server_protocol = $('#selected_server :selected').attr('protocol');
		server_port = $('#selected_server :selected').attr('port');
		//self.port.emit('connect', server_uuid);
		emitConnect();
	} else {
		//self.port.emit('disconnect');
		emitDisconnect();
		disconnect();
	}
})
